<?php
session_start();
$username = isset( $_SESSION['username'] ) ? $_SESSION['username'] : "";
if ( !$username ) {
	exit('logout');
}
include_once 'config.php';
include_once 'init.php';
include_once 'includes/plugin.php';

if(file_exists(PLUGIN_PATH.'posts/Post.php')){
	include_once PLUGIN_PATH.'posts/Post.php';
}

if ( ADMIN_DEMO ) {
	exit('ADMIN DEMO');
}
if ( !USER_ADMIN ) {
	exit('access forbidden!');
}
if ( !PRETTY_URL ) {
	exit('Pretty url is disabled!');
}
function containsAmpersand($string) {
    return strpos($string, '&') !== false;
}
$str = '<?xml version="1.0" encoding="UTF-8"?>
<urlset
    xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9
    http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">
<!-- generated by CloudArcade -->';

//domain
$str = $str.'
<url>
	<loc>'.DOMAIN.'</loc>
	<priority>1.00</priority>
</url>';
//categories
$cats = get_all_categories();
foreach ($cats as $cat) {
	if (!containsAmpersand($cat->slug)) {
		$str = $str.'
		<url>
			<loc>'.get_permalink('category', $cat->slug).'</loc>
			<changefreq>weekly</changefreq>
		</url>';
	}
}
//blog
if(defined('POST_ACTIVE')){
	$posts = Post::getList()['results'];
	if($posts){
		foreach ($posts as $post) {
			if (!containsAmpersand($post->slug)) {
				$str = $str.'
				<url>
					<loc>'.get_permalink('post', $post->slug).'</loc>
				</url>';
			}
		}
	}
}
//games
$conn = new PDO(DB_DSN, DB_USERNAME, DB_PASSWORD);
$conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
$sql = "SELECT slug FROM games WHERE published = 1 ORDER BY id DESC LIMIT 5000";
$st = $conn->prepare($sql);
$st->execute();
$games = $st -> fetchAll();
$conn = null;
foreach ($games as $game) {
	if (!containsAmpersand($game['slug'])) {
		$str = $str.'
		<url>
			<loc>'.get_permalink('game', $game['slug']).'</loc>
		</url>';
	}
}
$str = $str.'</urlset>';

$sitemap = fopen("sitemap.xml", "w") or die("Unable to open file!");
$content = $str;
fwrite($sitemap, $content);
fclose($sitemap);

if(!file_exists('robots.txt')){
$robots_txt = 'User-agent: *
Disallow: 
Disallow: /includes/
Disallow: /classes/
Disallow: /admin/
Disallow: /vendor/
Sitemap: /sitemap.xml';
	file_put_contents('robots.txt', $robots_txt);
}

header('Location: sitemap.xml');

?>